package msg_transfer

import (
	"dcg/game/msg_transfer/danmaku"
	"dcg/game/msg_transfer/gift"
	"dcg/game/svc"
)

var (
	danmakuMsgToPush danmaku.MsgToPushHandler
	giftMsgToPush    gift.MsgToPushHandler
)

func Init(svc *svc.ServiceContext) {
	danmakuMsgToPush.Init(svc)
	giftMsgToPush.Init(svc)
}

func Run() {
	go danmakuMsgToPush.ConsumerGroup.RegisterHandlerAndConsumer(&danmakuMsgToPush)
	go giftMsgToPush.ConsumerGroup.RegisterHandlerAndConsumer(&giftMsgToPush)
}
